import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import NodeGroup from '../NodeGroup';
import { numeric } from '../utils';

var keyAccessor = function keyAccessor() {
  return '$$key$$';
};

var Animate =
/*#__PURE__*/
function (_Component) {
  _inherits(Animate, _Component);

  function Animate() {
    _classCallCheck(this, Animate);

    return _possibleConstructorReturn(this, _getPrototypeOf(Animate).apply(this, arguments));
  }

  _createClass(Animate, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          show = _this$props.show,
          start = _this$props.start,
          enter = _this$props.enter,
          update = _this$props.update,
          leave = _this$props.leave,
          wrapper = _this$props.wrapper,
          wrapperClass = _this$props.wrapperClass,
          wrapperStyle = _this$props.wrapperStyle,
          interpolation = _this$props.interpolation,
          children = _this$props.children;
      var data = typeof start === 'function' ? start() : start;
      return React.createElement(NodeGroup, {
        data: show ? [data] : [],
        start: function start() {
          return data || {};
        },
        keyAccessor: keyAccessor,
        interpolation: interpolation,
        enter: typeof enter === 'function' ? enter : function () {
          return enter;
        },
        update: typeof update === 'function' ? update : function () {
          return update;
        },
        leave: typeof leave === 'function' ? leave : function () {
          return leave;
        },
        wrapper: wrapper,
        wrapperClass: wrapperClass,
        wrapperStyle: wrapperStyle
      }, children || React.createElement("div", null));
    }
  }]);

  return Animate;
}(Component);

Animate.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Tag for wrapping elment: 'g', 'span', etc.  No custom components.
   */
  wrapper: PropTypes.string,

  /**
   * Class to be applied to wrapper.
   */
  wrapperClass: PropTypes.string,

  /**
   * Style object for wrapper.
   */
  wrapperStyle: PropTypes.object,

  /**
   * Boolean value that determines if the child should be rendered or not.
   */
  show: PropTypes.bool.isRequired,

  /**
   * A function that returns an interpolator given the begin value, end value, atrr and namespace. See docs for more.
   */
  interpolation: PropTypes.func,

  /**
   * An object or function that returns an obejct to be used as the starting state.
   */
  start: PropTypes.oneOfType([PropTypes.func, PropTypes.object]),

  /**
   * An object, array of objects, or function that returns an object or array of objects describing how the state should transform on enter.
   */
  enter: PropTypes.oneOfType([PropTypes.func, PropTypes.array, PropTypes.object]),

  /**
   * An object, array of objects, or function that returns an object or array of objects describing how the state should transform on update. ***Note:*** although not required, in most cases it make sense to specify an update prop to handle interrupted enter and leave transitions.
   */
  update: PropTypes.oneOfType([PropTypes.func, PropTypes.array, PropTypes.object]),

  /**
   * An object, array of objects, or function that returns an object or array of objects describing how the state should transform on leave.
   */
  leave: PropTypes.oneOfType([PropTypes.func, PropTypes.array, PropTypes.object]),

  /**
   * A React node. No custom components.
   */
  children: PropTypes.node
} : {};
Animate.defaultProps = {
  show: true,
  wrapper: 'div',
  interpolation: numeric
};
export default Animate;