import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { BaseNode, interval } from 'kapellmeister';
import mergeKeys from '../core/mergeKeys';
import { ENTER, UPDATE, LEAVE } from '../core/types';
import { numeric, kebabCase } from '../utils';

var NodeGroup =
/*#__PURE__*/
function (_Component) {
  _inherits(NodeGroup, _Component);

  function NodeGroup(props) {
    var _this;

    _classCallCheck(this, NodeGroup);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(NodeGroup).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "ref", React.createRef());

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "animate", function () {
      var _this$state = _this.state,
          nodeKeys = _this$state.nodeKeys,
          nodeHash = _this$state.nodeHash;

      if (_this.unmounting) {
        return;
      }

      var pending = false;

      for (var i = 0; i < nodeKeys.length; i++) {
        var k = nodeKeys[i];
        var n = nodeHash[k];
        var isTransitioning = n.isTransitioning();

        if (isTransitioning) {
          pending = true;
        }

        if (n.type === LEAVE && !isTransitioning) {
          if (n.mounted === true) {
            n.unmount();
          }

          delete nodeHash[k];
          nodeKeys.splice(i, 1);
          i--;
        }
      }

      if (!pending) {
        _this.interval.stop();
      }

      var _loop = function _loop(_i) {
        var k = nodeKeys[_i];
        var n = nodeHash[k];

        if (!n.mounted) {
          var parent = _this.ref.current;

          var child = _this.createChild(_this.props.children, n, parent, k, _i);

          n.mounted = true;

          n.unmount = function () {
            parent.removeChild(child);
          };
        } else {
          n.updaters.forEach(function (updater) {
            updater.call(n, k, _i);
          });
        }
      };

      for (var _i = 0; _i < nodeKeys.length; _i++) {
        _loop(_i);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "interval", null);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "unmounting", false);

    var interpolation = props.interpolation;

    var Node =
    /*#__PURE__*/
    function (_BaseNode) {
      _inherits(Node, _BaseNode);

      function Node(key, data) {
        var _this2;

        _classCallCheck(this, Node);

        _this2 = _possibleConstructorReturn(this, _getPrototypeOf(Node).call(this));

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this2)), "getInterpolator", interpolation);

        _this2.key = key;
        _this2.data = data;
        _this2.type = ENTER;
        return _this2;
      }

      return Node;
    }(BaseNode);

    _this.state = {
      Node: Node,
      nodeKeys: [],
      nodeHash: {},
      nodes: [],
      data: null
    };
    return _this;
  }

  _createClass(NodeGroup, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.startInterval();
    }
  }, {
    key: "createChild",
    value: function createChild(template, node, parent, key, index) {
      var _this3 = this;

      var state = node.state,
          data = node.data;
      var nameSpace = this.ref.current.namespaceURI;
      var child = document.createElementNS(nameSpace, template.type);
      parent.appendChild(child);

      var _loop2 = function _loop2(prop) {
        var attr = kebabCase(prop);

        if (prop === 'children') {
          if (typeof template.props.children === 'function') {
            var value = template.props.children;
            var textNode = document.createTextNode(value(state, data, key, index));
            child.appendChild(textNode);
            node.updaters.push(function (k, i) {
              textNode.nodeValue = value(this.state, this.data, k, i);
            });
          } else {
            React.Children.forEach(template.props.children, function (c) {
              _this3.createChild(c, node, child, key, index);
            });
          }
        } else if (prop === 'className') {
          child.setAttribute('class', template.props[prop]);
        } else if (typeof template.props[prop] === 'string' || typeof template.props[prop] === 'number') {
          child.setAttribute(attr, template.props[prop]);
        } else if (typeof template.props[prop] === 'function') {
          var _value = template.props[prop];

          if (prop.startsWith('on')) {
            child.addEventListener(prop.slice(2).toLowerCase(), _value.call(child, state, data, key, index));
          } else {
            child.setAttribute(attr, _value(state, data, key, index));
            node.updaters.push(function (k, i) {
              child.setAttribute(attr, _value(this.state, this.data, k, i));
            });
          }
        }
      };

      for (var prop in template.props) {
        _loop2(prop);
      }

      return child;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.data !== this.props.data && !this.unmounting) {
        this.startInterval();
      }
    }
  }, {
    key: "startInterval",
    value: function startInterval() {
      if (!this.interval) {
        this.interval = interval(this.animate);
      } else {
        this.interval.restart(this.animate);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$state2 = this.state,
          nodeKeys = _this$state2.nodeKeys,
          nodeHash = _this$state2.nodeHash;
      this.unmounting = true;

      if (this.interval) {
        this.interval.stop();
      }

      nodeKeys.forEach(function (key) {
        nodeHash[key].stopTransitions();
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          _this$props$wrapper = _this$props.wrapper,
          wrapper = _this$props$wrapper === void 0 ? 'div' : _this$props$wrapper,
          _this$props$wrapperCl = _this$props.wrapperClass,
          wrapperClass = _this$props$wrapperCl === void 0 ? '' : _this$props$wrapperCl,
          _this$props$wrapperSt = _this$props.wrapperStyle,
          wrapperStyle = _this$props$wrapperSt === void 0 ? {} : _this$props$wrapperSt;
      return React.createElement(wrapper, {
        ref: this.ref,
        className: wrapperClass,
        style: wrapperStyle
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if (nextProps.data !== prevState.data) {
        var data = nextProps.data,
            keyAccessor = nextProps.keyAccessor,
            start = nextProps.start,
            enter = nextProps.enter,
            update = nextProps.update,
            leave = nextProps.leave;
        var Node = prevState.Node,
            nodeKeys = prevState.nodeKeys,
            nodeHash = prevState.nodeHash;
        var keyIndex = {};

        for (var i = 0; i < nodeKeys.length; i++) {
          keyIndex[nodeKeys[i]] = i;
        }

        var nextKeyIndex = {};
        var nextNodeKeys = [];

        for (var _i2 = 0; _i2 < data.length; _i2++) {
          var d = data[_i2];
          var k = keyAccessor(d, _i2);
          nextKeyIndex[k] = _i2;
          nextNodeKeys.push(k);

          if (keyIndex[k] === undefined) {
            var node = new Node(k, d);
            node.updaters = [];
            nodeHash[k] = node;
          }
        }

        for (var _i3 = 0; _i3 < nodeKeys.length; _i3++) {
          var _k = nodeKeys[_i3];
          var n = nodeHash[_k];

          if (nextKeyIndex[_k] !== undefined) {
            n.data = data[nextKeyIndex[_k]];
            n.type = UPDATE;
          } else {
            n.type = LEAVE;
          }
        }

        var mergedNodeKeys = mergeKeys(nodeKeys, keyIndex, nextNodeKeys, nextKeyIndex);

        for (var _i4 = 0; _i4 < mergedNodeKeys.length; _i4++) {
          var _k2 = mergedNodeKeys[_i4];
          var _n = nodeHash[_k2];
          var _d = _n.data;

          if (_n.type === ENTER) {
            _n.setState(start(_d, nextKeyIndex[_k2]));

            _n.transition(enter(_d, nextKeyIndex[_k2]));
          } else if (_n.type === LEAVE) {
            _n.transition(leave(_d, keyIndex[_k2]));
          } else {
            _n.transition(update(_d, nextKeyIndex[_k2]));
          }
        }

        return {
          data: data,
          nodeHash: nodeHash,
          nodeKeys: mergedNodeKeys
        };
      }

      return null;
    }
  }]);

  return NodeGroup;
}(Component);

NodeGroup.propTypes = process.env.NODE_ENV !== "production" ? {
  /**
   * Tag for wrapping elment: 'g', 'span', etc.  No custom components.
   */
  wrapper: PropTypes.string,

  /**
   * Class to be applied to wrapper.
   */
  wrapperClass: PropTypes.string,

  /**
   * Style object for wrapper.
   */
  wrapperStyle: PropTypes.object,

  /**
   * An array. The data prop is treated as immutable so the nodes will only update if prev.data !== next.data.
   */
  data: PropTypes.array.isRequired,

  /**
   * Function that returns a string key given the data and its index. Used to track which nodes are entering, updating and leaving.
   */
  keyAccessor: PropTypes.func.isRequired,

  /**
   * A function that returns an interpolator given the begin value, end value, attr and namespace. Defaults to numeric interpolation. See docs for more.
   */
  interpolation: PropTypes.func,

  /**
   * A function that returns the starting state. The function is passed the data and index and must return an object.
   */
  start: PropTypes.func.isRequired,

  /**
   * A function that **returns an object or array of objects** describing how the state should transform on enter.  The function is passed the data and index.
   */
  enter: PropTypes.func,

  /**
   * A function that **returns an object or array of objects** describing how the state should transform on update.  The function is passed the data and index.
   */
  update: PropTypes.func,

  /**
   * A function that **returns an object or array of objects** describing how the state should transform on leave.  The function is passed the data and index.
   */
  leave: PropTypes.func,

  /**
   * A React node. The node will be used as a template for each item in the array. No custom components.
   */
  children: PropTypes.node.isRequired
} : {};
NodeGroup.defaultProps = {
  enter: function enter() {},
  update: function update() {},
  leave: function leave() {},
  wrapper: 'div',
  interpolation: numeric
};
export default NodeGroup;